
/*   Compte à rebours du temps
* Pour afficheur 7 segments 6 digits.
* 
* Bouton "Stop décompte" sur PIN D4
* avec résistance de tirage 4K7 à la masse 
* 
*            Poussoir 
    Pin 4_____ ----_____  + 5 Volts
           |
          [ ]  4,7 K
           |
         Masse
*               
* Le bouton "reset" permet La remise à l'heure initiale.
* 
* Version 01 le 06 11 2016 
* 
* http://f5mna.free.fr
*/


#include "SevSeg.h"
 SevSeg sevseg; 
 
 long previousMillis = 0;    
 long interval = 1000;     // Décompte toutes les secondes         
 int heures, minutes, secondes,mn1,i,chiffre;
 unsigned long h0,h1,nombre;
 boolean decompte = false;
 boolean top = true;
 boolean top1 = true;
 boolean top2 = true;
 
 const int Bouton = 4;
 int EtatBouton;
 int DerEtatBouton = LOW;
 long DerTempsRebond = 0;
 long DelaiRebond = 50;
 
 void setup() {

   pinMode(Bouton, INPUT);     
   byte numDigits = 6;                          // Nombre de digits     byte numDigits = 6;  pour afficher les heures
   byte digitPins[] = {A4,A3,12,11,10,9};       // Selon câblage
   byte segmentPins[] = {A0,A1,A2,5,6,7,8,13};  // Selon cablage (a,b,c,d,e,f,g,point)};  
   sevseg.begin(COMMON_ANODE, numDigits, digitPins, segmentPins); // COMMON_CATHODE selon afficheurs utilisés
   sevseg.setBrightness(100);  // Luminosité de 0 à 100 
 
 
 //////////////////////////////////////////////////////////  
   heures = 12;         // Réglage arbitraire pour test
   minutes = 35;        // Réglage arbitraire pour test   
   i=52;                // Correspond ici aux secondes
 ////////////////////////////////////////////////////////////  

 
   if (i == 0) (minutes = minutes +1);
}

void loop() {

  
  sevseg.refreshDisplay(); 
  //////  Bouton arrêt de jeu //////////
  {
    int LireBt = digitalRead(Bouton);
    if (LireBt != DerEtatBouton) {
      DerTempsRebond = millis();
    }
    if ((millis() - DerTempsRebond) > DelaiRebond) {
      if (LireBt != EtatBouton) {
        EtatBouton = LireBt;
        if (EtatBouton == HIGH) {
        if (top2 == true) decompte = !decompte;
        if ((top1 == true) and (minutes > 0) and (i == 0))
        {(minutes = minutes -1);
        top1 = false;}          
        }
      }
    }
    DerEtatBouton = LireBt;
  }
  
/////////  Decompte //////////////

   unsigned long currentMillis = millis();  
   if(currentMillis - previousMillis > interval) {
   previousMillis = currentMillis; 
 
   if (decompte == true)  i = i - 1; 
   }  
   if (i<0) i = 59;   
   if (i == 0) (secondes = 59);    
   if (i > 0) top = true;    
   if ((i == 0) and (minutes > 0) and (top==true)){
   (minutes = minutes-1);  
   top = false;
   }    
   if ((i == 0) and (minutes == 0) and (heures > -1) and (top == true)){
   heures = heures - 1;   
   minutes = 59;
   top = false;
   }    
   if (heures == -1) {
    heures = 0;
    minutes = 0;
    top2 = false;   
    decompte = false;} 
    
    h0 = (heures * 100);      // transforme le temps en nombre entier pour affichage 7 segments.
    h1 = (h0 * 100); 

    mn1 = minutes * 100;    
    nombre = (h1+mn1+i);
    sevseg.setNumber((nombre),6); //  pour afficher les heures
    
}

